import {ScreenEvents} from "./../../libs/ui-from-dialogue/classes.js";
import {fromDynamicProperty,editDynamicProperty} from "./../../libs/ui-from-dialogue/utils.js";
import {BannerColors, BannerPatternIndex} from "./../../enumerations.js";


export class ResultSlot {
	static onAppear({player,target}){
		
		let conditions = {response:"enabledENABLED", recipeType: "none"};
		let [shieldSlotIndex, dyeSlotIndex, patternSlotIndex, patternSelectedIndex] = [fromDynamicProperty(player,"selected_loom_shield_item"),fromDynamicProperty(player,"selected_loom_dye_item"),fromDynamicProperty(player,"selected_loom_pattern_item"),fromDynamicProperty(player,"selected_loom_pattern")];
		if(shieldSlotIndex==-1) { conditions.response = conditions.response.replace("ENABLED",0); return conditions.response; };
		let shield = player.getComponent("minecraft:inventory").container.getItem(shieldSlotIndex);
		if(!ResultSlot.getLayer(shield,0)) {conditions.recipeType = "bannerColorRecipeType"; }else{ conditions.recipeType = "bannerPatternRecipeType"; };
		ResultSlot[conditions.recipeType]({player:player,shield:shield,conditions:conditions});
		
		return conditions.response;
		
	}
	static bannerColorRecipeType({player,shield,conditions}){
		if((shield?.getLore()?.length>=7)||(fromDynamicProperty(player,"selected_loom_dye_item")==-1)){ conditions.response = conditions.response.replace("ENABLED",0); return; };
		conditions.response = conditions.response.replace("ENABLED",1);
		
	}
	static bannerPatternRecipeType({player,shield,conditions}){
		if((shield?.getLore()?.length>=7)||(fromDynamicProperty(player,"selected_loom_pattern")==-1)||(fromDynamicProperty(player,"selected_loom_dye_item")==-1)){ conditions.response = conditions.response.replace("ENABLED",0); return; };
		conditions.response = conditions.response.replace("ENABLED",1);
	}
	static none({player}){
		conditions.response = conditions.response.replace("ENABLED",0);
		return;
	}
	static getLayer(shield,layer){
	  let layers = (shield.getLore()||[]);
	  return layers[layer];
	}
	static onPressed({player,target}){
		try{
		let pattern = fromDynamicProperty(player,"selected_loom_pattern");
		let patternItem = fromDynamicProperty(player,"selected_loom_pattern_item");
		let shieldSlot = player.getComponent("minecraft:inventory").container.getSlot(fromDynamicProperty(player,"selected_loom_shield_item"));
		let dyeOrBanner = player.getComponent("minecraft:inventory").container.getSlot(fromDynamicProperty(player,"selected_loom_dye_item"));
		let lore = (shieldSlot.getLore()||[]);
		if(!lore[0]){
			let banner=dyeOrBanner.getItem();
			let color = Object.keys(BannerColors)[banner.data];
			lore.push(color + " banner");
			shieldSlot.setLore(lore);
			(dyeOrBanner.amount>1) ? dyeOrBanner.amount-=1 : dyeOrBanner.clearItem();
			
			return;
		};
		let color = DyeSlot[dyeOrBanner.typeId].cN;
		let patternType = Object.keys(BannerPatternIndex)[pattern].replace("_", " ");
		lore.push(color + " " + patternType);
		shieldSlot.setLore(lore);
		(dyeOrBanner.amount>1) ? dyeOrBanner.amount-=1 : dyeOrBanner.clearItem();
		(patternItem!=-1) ? player.getComponent("minecraft:inventory").container.getSlot(patternItem).clearItem() : undefined;
		
		return;
	    }catch(error){}
	}
}
export function getLayer(shield,layer){
	let layers = (shield.getLore()||[]);
	return layers[layer];
};
export function findItems(player,items){
	let itms = [];
	let container = player.getComponent("minecraft:inventory").container;
	for(let slot = 0; slot<container.size; slot++){
		let item = container.getItem(slot);
		(items.some((i)=>i==item?.typeId)) ? itms.push(slot) : undefined;
	}
	return itms;
};

export function dyeSlotAppear({player,target}){
	let response = "enabledENABLED isImageIMAGE dataDATA texture_TEXTURE";
	let slot = fromDynamicProperty(player,"selected_loom_dye_item");
	let shieldSlot = fromDynamicProperty(player,"selected_loom_shield_item");
	if(shieldSlot==-1){
		response = response.replace("ENABLED",0); response = response.replace("IMAGE",1); response = response.replace("DATA",0); response= response.replace("TEXTURE","textures/none");
		return response;
	};
	let shield = player.getComponent("minecraft:inventory").container.getItem(shieldSlot);
	let [banner] = (shield?.getLore()??[]);
	if(banner?.endsWith("banner")){
		/*Accepts dyes*/
		let dyes = findItems(player,Object.keys(DyeSlot));
		((fromDynamicProperty(player,"selected_loom_dye_item")!=-1)&&(!dyes.some((nombre)=>nombre==slot))) ? editDynamicProperty(player,"selected_loom_dye_item",-1) : undefined;
		if(dyes.length<=0){ response = response.replace("ENABLED",0); response = response.replace("IMAGE",1); response = response.replace("DATA",0); response= response.replace("TEXTURE","textures/none");}else{
			response= response.replace("IMAGE",1);
			if(dyes.length==1){
				let dye = player.getComponent("minecraft:inventory").container.getItem(dyes[0]);
				editDynamicProperty(player,"selected_loom_dye_item",dyes[0]);
				response = response.replace("ENABLED",0).replace("DATA",0).replace("TEXTURE",DyeSlot[dye.typeId].t);
				
			}else{
				((fromDynamicProperty(player,"selected_loom_dye_item")==-1)||(!dyes.some((nombre)=>nombre==slot))) ? editDynamicProperty(player,"selected_loom_dye_item",dyes[0]) : undefined;
				let dye = player.getComponent("minecraft:inventory").container.getItem((fromDynamicProperty(player,"selected_loom_dye_item")==-1) ? dyes[0] : fromDynamicProperty(player,"selected_loom_dye_item"));
				response = response.replace("ENABLED",1).replace("DATA",0).replace("TEXTURE",DyeSlot[dye.typeId].t);
			}
	   };
	}else{
		let banners = findItems(player,["minecraft:banner"]);
		((fromDynamicProperty(player,"selected_loom_dye_item")!=-1)&&(!banners.some((nombre)=>nombre==slot))) ? editDynamicProperty(player,"selected_loom_dye_item",-1) : undefined;
		if(banners.length<=0){ response = response.replace("ENABLED",0); response = response.replace("IMAGE",1); response = response.replace("DATA",0); response= response.replace("TEXTURE","textures/none");}else{
			response= response.replace("IMAGE",0);
			/*Accepts banners, do not use banners who has data on it*/
			if(banners.length==1){
				let banner = player.getComponent("minecraft:inventory").container.getItem(banners[0]);
				editDynamicProperty(player,"selected_loom_dye_item",banners[0]);
				response = response.replace("ENABLED",0).replace("DATA",banner.data).replace("TEXTURE","textures/none");
				
			}else{
				((fromDynamicProperty(player,"selected_loom_dye_item")==-1)||(!banners.some((nombre)=>nombre==slot))) ? editDynamicProperty(player,"selected_loom_dye_item",banners[0]) : undefined;
				let banner = player.getComponent("minecraft:inventory").container.getItem((fromDynamicProperty(player,"selected_loom_dye_item")==-1) ? banners[0] : fromDynamicProperty(player,"selected_loom_dye_item"));
				response = response.replace("ENABLED",1).replace("DATA",banner.data).replace("TEXTURE","textures/none");
			}
	   }
	};
	
	return response;
};
export function dyeSlotPressed({player,target}){
	try{
	let shield = player.getComponent("minecraft:inventory").container.getItem((fromDynamicProperty(player,"selected_loom_shield_item")==-1) ? 0 : fromDynamicProperty(player,"selected_loom_shield_item"));
	let [banner] = (shield?.getLore()??[]);
	let slot= fromDynamicProperty(player,"selected_loom_dye_item");
    let items = (banner?.endsWith("banner")) ? findItems(player,Object.keys(DyeSlot)) : findItems(player,["minecraft:banner"]);
    let indx = items.indexOf(slot);
    (indx==(items.length-1)) ? indx=0 : indx+=1;
    editDynamicProperty(player,"selected_loom_dye_item", items [indx]);
    }catch(error){}
}; 
export function dyeSlotTexture({player, target}){
	let texture = "textures/ui/loom_dye_empty";
	let shieldSlot = fromDynamicProperty(player,"selected_loom_shield_item");
	if(shieldSlot==-1){
		texture="textures/ui/loom_banner_empty";
		return texture;
	};
	
	let shield = player.getComponent("minecraft:inventory").container.getItem(shieldSlot);
	let [banner] = (shield?.getLore()??[]);
	let slot= fromDynamicProperty(player,"selected_loom_dye_item");
	let type = (banner?.endsWith("banner")) ? 0 : 1;
	(slot==-1) ? texture=["textures/ui/loom_dye_empty","textures/ui/loom_banner_empty"][type] : texture="textures/none";
	return texture;
}
export function bannerPatternAppear({player,target}){
	let response = "enabled0 texture_TEXTURE";
	let pattern = fromDynamicProperty(player,"selected_loom_pattern");
	let shieldSlot =fromDynamicProperty(player,"selected_loom_shield_item");
	if(shieldSlot==-1){
		response=response.replace("TEXTURE","textures/none");
		return response;
	};
	let shield = player.getComponent("minecraft:inventory").container.getItem(shieldSlot);
	let [banner] = (shield?.getLore()??[]);
	if(banner?.endsWith("banner")){
		let patterns = findItems(player,Object.keys(BannerPatternSlot));
		if(patterns.length<=0){ response= response.replace("TEXTURE","textures/none");}else{
			(Object.values(BannerPatternSlot).some((p)=>BannerPatternIndex[p]==pattern)) ? response= response.replace("TEXTURE","textures/items/banner_pattern") : response= response.replace("TEXTURE","textures/none");
	   };
	}else{ response=response.replace("TEXTURE","textures/none");};
	
	return response;
};
export function bannerPatternTexture({player}){
	let shieldSlot = fromDynamicProperty(player,"selected_loom_shield_item");
	if(shieldSlot==-1){
		return "textures/ui/loom_pattern_item_empty";
	};
	let pattern = fromDynamicProperty(player,"selected_loom_pattern");
	let texture = "textures/ui/loom_pattern_item_empty";
	let shield = player.getComponent("minecraft:inventory").container.getItem(shieldSlot);
	let [banner] = (shield?.getLore()??[]);
	if(banner?.endsWith("banner")){
		(Object.values(BannerPatternSlot).some((p)=>BannerPatternIndex[p]==pattern)) ? texture="textures/none" : texture="textures/ui/loom_pattern_item_empty";
		return texture;
	};
	return texture;
};

export function bannerColorTexture({player}){
	let texture = "textures/none";
	let slot = fromDynamicProperty(player,"selected_loom_shield_item");
	if(slot==-1){
      return texture;
     };
    let shield = player.getComponent("minecraft:inventory").container.getItem(slot);
    let layer = getLayer(shield,0);
    if(layer===undefined){
    	let banner = fromDynamicProperty(player,"selected_loom_dye_item");
        (banner==-1) ? texture="textures/none" : texture=`textures/shields/customizable/patterns/banner/${player.getComponent("minecraft:inventory").container.getItem(banner).data}`;
        return texture;
    };
    let [color] = layer.split(" ");
    texture = "textures/shields/customizable/patterns/banner/" + BannerColors[color];
	return texture;
};

export function layerTexture(player,layerIndex){
	let texture = "textures/none";
	let slot = fromDynamicProperty(player,"selected_loom_shield_item");
	if(slot==-1){
      return texture;
     };
    let shield = player.getComponent("minecraft:inventory").container.getItem(slot);
    let layer = getLayer(shield,layerIndex);
    if(layer===undefined){
    	let dye = fromDynamicProperty(player,"selected_loom_dye_item");
        let bannerPattern = fromDynamicProperty(player,"selected_loom_pattern");
        ((dye==-1)||(bannerPattern==-1)||(getLayer(shield,layerIndex-1)===undefined)) ? texture="textures/none" : texture=`textures/shields/customizable/patterns/${Object.keys(BannerPatternIndex)[bannerPattern]}/${BannerColors[DyeSlot[player.getComponent("minecraft:inventory").container.getItem(dye).typeId].cN]}`;
        return texture;
    };
    let [color,...bannerPattern] = layer.split(" ");
    bannerPattern = bannerPattern.join("_");
    texture = "textures/shields/customizable/patterns/" + bannerPattern + "/" + BannerColors[color];
	return texture;
};

export const DyeSlot = {
	"minecraft:white_dye": {
		cN: "white",
		t: "textures/items/dye_powder_white_new"
	},
	"minecraft:bone_meal": {
		cN: "white",
		t: "textures/items/dye_powder_white"
	},
	"minecraft:orange_dye": {
		cN: "orange",
		t: "textures/items/dye_powder_orange"
	},
	"minecraft:lapis_lazuli": {
		t: "textures/items/dye_powder_blue",
		cN: "blue"
	},
	"minecraft:blue_dye": {
		t: "textures/items/dye_powder_blue_new",
		cN: "blue"
	},
	"minecraft:magenta_dye": {
		t: "textures/items/dye_powder_magenta",
		cN: "magenta"
	},
	"minecraft:light_blue_dye": {
		t: "textures/items/dye_powder_light_blue",
		cN: "light_blue"
	},
	"minecraft:yellow_dye": {
		t: "textures/items/dye_powder_yellow",
		cN: "yellow"
	},
	"minecraft:lime_dye": {
		t: "textures/items/dye_powder_lime",
		cN: "lime"
	},
	"minecraft:pink_dye": {
		t: "textures/items/dye_powder_pink",
		cN: "pink"
	},
	"minecraft:gray_dye": {
		t: "textures/items/dye_powder_gray",
		cN: "gray"
	},
	"minecraft:light_gray_dye": {
		t: "textures/items/dye_powder_silver",
		cN: "light_gray"
	},
	"minecraft:cyan_dye": {
		t: "textures/items/dye_powder_cyan",
		cN: "cyan"
	},
	"minecraft:purple_dye": {
		t: "textures/items/dye_powder_purple",
		cN: "purple"
	},
	"minecraft:brown_dye": {
		t: "textures/items/dye_powder_brown_new",
		cN: "brown"
	},
	"minecraft:cocoa_beans": {
		t: "textures/items/dye_powder_brown",
		cN: "brown"
	},
	"minecraft:green_dye": {
		t: "textures/items/dye_powder_green",
		cN: "green"
	},
	"minecraft:black_dye": {
		t: "textures/items/dye_powder_black_new",
		cN: "black"
	},
	"minecraft:ink_sac": {
		t: "textures/items/dye_powder_black",
		cN: "black"
	},
	"minecraft:red_dye": {
		t: "textures/items/dye_powder_red",
		cN: "red"
	}
};

export const BannerPatternSlot = {
	"minecraft:bordure_indented_banner_pattern": "bordure_indented",
    "minecraft:creeper_banner_pattern": "creeper_charge",
    "minecraft:field_masoned_banner_pattern": "field_masoned",
    "minecraft:flower_banner_pattern": "flower_charge",
    "minecraft:globe_banner_pattern": "globe",
    "minecraft:mojang_banner_pattern": "thing_charge",
    "minecraft:skull_banner_pattern": "skull_charge",
    "minecraft:piglin_banner_pattern": "snout"
};

export const ShieldTextures = {
	"add:wooden_shield": "textures/items/base_shield",
	"add:stone_shield": "textures/items/stone_shield",
	"add:golden_shield": "textures/items/golden_shield",
	"add:iron_shield": "textures/items/iron_shield",
	"add:diamond_shield": "textures/items/diamond_shield",
	"add:obsidian_shield": "textures/items/obsidian_shield",
	"add:netherite_shield": "textures/items/netherite_shield"
};
export const ShieldPreview = {
	"add:wooden_shield": "textures/shields/wooden_shield",
	"add:stone_shield": "textures/shields/stone_shield",
	"add:golden_shield": "textures/shields/golden_shield",
	"add:iron_shield": "textures/shields/iron_shield",
	"add:diamond_shield": "textures/shields/diamond_shield",
	"add:obsidian_shield": "textures/shields/obsidian_shield",
	"add:netherite_shield": "textures/shields/netherite_shield"
};

export const Loom_For_Shield_Sheet = {
	max_pages: 10,
	name: "loom_for_shield",
	pages: [
	  {
		type: "action",
		page: 0,
		name: "tile.add:loom_for_shield.name",
		body: "",
		title: "Loom For Shield",
		onClose: ({player,target})=>{
			editDynamicProperty(player,"selected_loom_pattern",-1);
			editDynamicProperty(player,"selected_loom_shield_item",-1);
			editDynamicProperty(player,"selected_loom_dye_item",-1);
			editDynamicProperty(player,"selected_loom_pattern_item",-1);
		},
		elements: [
		  { name: (c)=>{ let patterns = findItems(c.player,Object.keys(BannerPatternSlot)); (patterns.length<=0) ? editDynamicProperty(c.player,"selected_loom_pattern_item",-1) : undefined; let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = findItems(c.player,["minecraft:creeper_banner_pattern"]).length; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ let patterns = findItems(c.player,["minecraft:creeper_banner_pattern"]); editDynamicProperty(c.player,"selected_loom_pattern_item",patterns[0]); editDynamicProperty(c.player,"selected_loom_pattern",c.value); }, to: 0, show: true, icon: "textures/shields/customizable/patterns/creeper_charge/15" },
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = findItems(c.player,["minecraft:skull_banner_pattern"]).length; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ let patterns = findItems(c.player,["minecraft:skull_banner_pattern"]); editDynamicProperty(c.player,"selected_loom_pattern_item",patterns[0]); editDynamicProperty(c.player,"selected_loom_pattern",c.value);  }, to: 0, show: true,icon: "textures/shields/customizable/patterns/skull_charge/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = findItems(c.player,["minecraft:flower_banner_pattern"]).length; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ let patterns = findItems(c.player,["minecraft:flower_banner_pattern"]); editDynamicProperty(c.player,"selected_loom_pattern_item",patterns[0]); editDynamicProperty(c.player,"selected_loom_pattern",c.value);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/flower_charge/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = findItems(c.player,["minecraft:mojang_banner_pattern"]).length; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ let patterns = findItems(c.player,["minecraft:mojang_banner_pattern"]); editDynamicProperty(c.player,"selected_loom_pattern_item",patterns[0]); editDynamicProperty(c.player,"selected_loom_pattern",c.value);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/thing_charge/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = findItems(c.player,["minecraft:field_masoned_banner_pattern"]).length; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ let patterns = findItems(c.player,["minecraft:field_masoned_banner_pattern"]); editDynamicProperty(c.player,"selected_loom_pattern_item",patterns[0]); editDynamicProperty(c.player,"selected_loom_pattern",c.value);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/field_masoned/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/bordure/15"},
		
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = findItems(c.player,["minecraft:globe_banner_pattern"]).length; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/globe/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/roundel/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/salitre/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/per_bend_inverted/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/per_bend_sinister_inverted/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/per_bend_sinister/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/per_bend/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/gradient/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/base_gradient/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/per_fress/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/per_fress_inverted/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/per_pale/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/per_pale_inverted/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/lozenge/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/paly/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/base_dexter_canton/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/base_sinister_canton/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/chief_dexter_canton/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/chief_sinister_canton/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/cross/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/base_fess/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/pale/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/bend_sinister/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/bend/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/pale_dexter/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/fess/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/pale_sinister/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/chief_fess/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/chevron/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/inverted_chevron/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/base_indented/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = 1; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ editDynamicProperty(c.player,"selected_loom_pattern",c.value); editDynamicProperty(c.player,"selected_loom_pattern_item",-1);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/chief_indented/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = findItems(c.player,["minecraft:bordure_indented_banner_pattern"]).length; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ let patterns = findItems(c.player,["minecraft:bordure_indented_banner_pattern"]); editDynamicProperty(c.player,"selected_loom_pattern_item",patterns[0]); editDynamicProperty(c.player,"selected_loom_pattern",c.value);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/bordure_indented/15"},
		  { name: (c)=>{ let selected = fromDynamicProperty(c.player,"selected_loom_pattern"); let enabled = findItems(c.player,["minecraft:piglin_banner_pattern"]).length; return `selected${selected} enabled${enabled}`;}, action: (c)=>{ let patterns = findItems(c.player,["minecraft:piglin_banner_pattern"]); editDynamicProperty(c.player,"selected_loom_pattern_item",patterns[0]); editDynamicProperty(c.player,"selected_loom_pattern",c.value);}, to: 0, show: true, icon: "textures/shields/customizable/patterns/snout/15"},
		  { name: (c)=>{ let enabled = 0;  let shields = findItems(c.player,Object.keys(ShieldPreview)); (shields.length<=0) ? editDynamicProperty(c.player,"selected_loom_shield_item",-1) : undefined; let texture = (fromDynamicProperty(c.player,"selected_loom_shield_item")>=0) ? ShieldTextures[c.player.getComponent("minecraft:inventory").container.getItem(fromDynamicProperty(c.player,"selected_loom_shield_item")).typeId] : "textures/none"; ((fromDynamicProperty(c.player,"selected_loom_shield_item")==-1)&&(shields.length>=1)) ? [editDynamicProperty(c.player,"selected_loom_shield_item", shields [0]),texture=ShieldTextures[c.player.getComponent("minecraft:inventory").container.getItem(shields[0]).typeId]] : undefined; (shields.length>1) ? enabled = 1 : undefined; return `enabled${enabled} texture_${texture}`; }, action: (c)=>{ try{ let shields = findItems(c.player,Object.keys(ShieldPreview)); let indx = shields.indexOf(fromDynamicProperty(c.player,"selected_loom_shield_item")); (indx==(shields.length-1)) ? indx=0 : indx+=1; editDynamicProperty(c.player,"selected_loom_shield_item",shields[indx]);}catch(error){}; }, to: 0, show: true, icon: (c)=>{let slot =fromDynamicProperty(c.player,"selected_loom_shield_item"); let texture="texture/ui/empty_armor_slot_shield"; (slot==-1) ? texture="textures/ui/empty_armor_slot_shield" : texture="texture/none"; return texture;} },
		  { name: dyeSlotAppear, action: dyeSlotPressed, to: 0, show: true, icon: dyeSlotTexture},
		  { name: bannerPatternAppear, action: null, to: 0, show: true, icon: bannerPatternTexture },
		  { name: ResultSlot.onAppear, action: ResultSlot.onPressed, to: 0, show: true},
		  { name: "shield type preview", action: null, to: 0, show: true, icon: ({player})=>{let texture = "textures/none"; let slot = fromDynamicProperty(player,"selected_loom_shield_item"); let shield = (slot==-1) ? texture="textures/none" : texture=ShieldPreview[player.getComponent("minecraft:inventory").container.getItem(slot).typeId]; return texture;} },
		  { name: "layer1 preview", action: null, to: 0, show: true, icon: bannerColorTexture },
		  { name: "layer2 preview", action: null, to: 0, show: true, icon: (c)=>{ return layerTexture(c.player,1); } },
		  { name: "layer3 preview", action: null, to: 0, show: true, icon: (c)=>{ return layerTexture(c.player,2); } },
		  { name: "layer4 preview", action: null, to: 0, show: true, icon: (c)=>{ return layerTexture(c.player,3); } },
		  { name: "layer5 preview", action: null, to: 0, show: true, icon: (c)=>{ return layerTexture(c.player,4); } },
		  { name: "layer6 preview", action: null, to: 0, show: true, icon: (c)=>{ return layerTexture(c.player,5); } },
		  { name: "layer7 preview", action: null, to: 0, show: true, icon: (c)=>{ return layerTexture(c.player,6); } }
		]
	  }
	]
}
export const Loom_For_Shield_Event = ScreenEvents.beforeItemUseOn((e)=>{
	let response = {player: undefined, target: undefined };
	let {source, blockLocation } = e;
	let block = source.dimension.getBlock(blockLocation);
	if((source?.typeId=="minecraft:player") && (block?.typeId=="add:loom_for_shield")){
		let item = source.getComponent("minecraft:inventory").container.getItem(source.selectedSlot);
	    if((source.isSneaking&&!item) || (!source.isSneaking)){response.player = source; response.target = block;}
	};
	return response;
},Loom_For_Shield_Sheet);